com.smartgwt.client.widgets.form.fields

## Class MiniDateRangeItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.StaticTextItem
          - - com.smartgwt.client.widgets.form.fields.MiniDateRangeItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPendingStatusChangedHandlers, HasPickerIconClickHandlers, HasShowContextMenuHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers, HasValueIconClickHandlers

      public class MiniDateRangeItem
      extends StaticTextItem

  Provides a compact interface for editing a date range, by providing a formatted, read-only display of the current selected date range with an icon to launch a `DateRangeDialog` to edit the range.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `FormItem.CustomStateGetter, FormItem.StateCustomizer`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MiniDateRangeItem()`
    `MiniDateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `MiniDateRangeItem(java.lang.String name)`
    `MiniDateRangeItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.Boolean` | `getAllowRelativeDates()` Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
    `java.lang.Boolean` | `getAutoValidate()` If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
    `java.lang.Boolean` | `getCanFocus()` MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog.
    `java.lang.Boolean` | `getCanTabToIcons()` MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element.
    `DateDisplayFormat` | `getDateDisplayFormat()` Format for displaying dates to the user.
    `java.util.Date` | `getFromDate()` Initial value for the "from" date.
    `java.lang.String` | `getFromDateOnlyPrefix()` The text to prepend to the formatted date when only a `fromDate` is supplied.
    `static MiniDateRangeItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `FormItemIcon` | `getPickerIcon()` Icon that launches a `DateChooser` for choosing an absolute date.
    `java.lang.String` | `getPickerIconPrompt()` The prompt to show when the mouse is hovered over the `pickerIcon`.
    `DateRangeDialog` | `getRangeDialog()` Pop-up `DateRangeDialog` for entering a date range.
    `java.lang.Boolean` | `getShouldSaveValue()` Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    `java.lang.String` | `getTextBoxStyle()` Base CSS class name for a form item's text box element.
    `java.util.Date` | `getToDate()` Initial value for the "to" date.
    `java.lang.String` | `getToDateOnlyPrefix()` The text to prepend to the formatted date when only a `toDate` is supplied.
    `DateRange` | `getValue()` Retrieves the current value of this dateRangeItem.
    `java.lang.Boolean` | `hasAdvancedCriteria()` Overridden to return true: dateRangeItems always generate AdvancedCriteria.
    `void` | `setAllowRelativeDates(java.lang.Boolean allowRelativeDates)` Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
    `void` | `setAutoValidate(java.lang.Boolean autoValidate)` If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
    `void` | `setCanFocus(java.lang.Boolean canFocus)` MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog.
    `void` | `setCanTabToIcons(java.lang.Boolean canTabToIcons)` MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element.
    `void` | `setCriterionGetter(FormItemCriterionGetter getter)` The default `getCriterion()` implementation returns the Criterion entered in the fields shown in the `rangeDialog`.
    `void` | `setDateDisplayFormat(DateDisplayFormat dateDisplayFormat)` Format for displaying dates to the user.
    `static void` | `setDefaultProperties(MiniDateRangeItem miniDateRangeItemProperties)` Class level method to set the default properties of this class.
    `void` | `setFromDate(java.util.Date fromDate)` Initial value for the "from" date.
    `void` | `setFromDateOnlyPrefix(java.lang.String fromDateOnlyPrefix)` The text to prepend to the formatted date when only a `fromDate` is supplied.
    `void` | `setPickerIcon(FormItemIcon pickerIcon)` Icon that launches a `DateChooser` for choosing an absolute date.
    `void` | `setPickerIconPrompt(java.lang.String pickerIconPrompt)` The prompt to show when the mouse is hovered over the `pickerIcon`.
    `void` | `setShouldSaveValue(java.lang.Boolean shouldSaveValue)` Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    `void` | `setTextBoxStyle(java.lang.String textBoxStyle)` Base CSS class name for a form item's text box element.
    `void` | `setToDate(java.util.Date toDate)` Initial value for the "to" date.
    `void` | `setToDateOnlyPrefix(java.lang.String toDateOnlyPrefix)` The text to prepend to the formatted date when only a `toDate` is supplied.
    `void` | `setValue(DateRange value)` Sets the value for this dateRangeItem.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.StaticTextItem

      `getApplyAlignToText, getApplyHeightToTextBox, getCanSelectText, getClipValue, getDateFormatter, getEditProxyConstructor, getEscapeHTML, getWrap, setApplyAlignToText, setApplyHeightToTextBox, setCanSelectText, setClipValue, setDateFormatter, setDefaultProperties, setEditProxyConstructor, setEscapeHTML, setWrap`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserInputType, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHeight, getHeightAsString, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultiple, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionDataSource, getOptionDataSourceAsString, getOptionFilterContext, getOptionOperationId, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPicker, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPixelHeight, getPixelWidth, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredWhen, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIcon, getShowPickerIconOnFocus, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStaticHeight, getStopOnError, getSupportsCutPasteEvents, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapHintText, getWrapTitle, handleWarnOnEditorTypeConversion, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isFocused, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserInputType, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanEditOpaqueValues, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCriterionSetter, setCustomStateGetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHeight, setHeight, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultiple, setMultipleValueSeparator, setName, setNullProperty, setOperator, setOptionCriteria, setOptionDataSource, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOriginalValueMessage, setPickerIconHeight, setPickerIconName, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredWhen, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIcon, setShowPickerIconOnFocus, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setSupportsCutPasteEvents, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapHintText, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, storeValue, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### MiniDateRangeItem

          public MiniDateRangeItem()

    - #### MiniDateRangeItem

          public MiniDateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### MiniDateRangeItem

          public MiniDateRangeItem(java.lang.String name)

    - #### MiniDateRangeItem

          public MiniDateRangeItem(java.lang.String name,
                                   java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static MiniDateRangeItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setAllowRelativeDates

          public void setAllowRelativeDates(java.lang.Boolean allowRelativeDates)

      Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
      Parameters:
        `allowRelativeDates` - New allowRelativeDates value. Default value is true

    - #### getAllowRelativeDates

          public java.lang.Boolean getAllowRelativeDates()

      Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
      Returns:
        Current allowRelativeDates value. Default value is true

    - #### setAutoValidate

          public void setAutoValidate(java.lang.Boolean autoValidate)

      If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
      If this method is called after the component has been drawn/initialized: Setter for `autoValidate`
      Parameters:
        `autoValidate` - New auto-validate setting. Default value is true

    - #### getAutoValidate

          public java.lang.Boolean getAutoValidate()

      If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
      Returns:
        Current autoValidate value. Default value is true

    - #### setCanFocus

          public void setCanFocus(java.lang.Boolean canFocus)

      MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog. Set canFocus to false to suppress this behavior.
      Overrides:
        `setCanFocus` in class `FormItem`
      Parameters:
        `canFocus` - New canFocus value. Default value is true
      See Also:
        `Focus overview and related methods`

    - #### getCanFocus

          public java.lang.Boolean getCanFocus()

      MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog. Set canFocus to false to suppress this behavior.
      Overrides:
        `getCanFocus` in class `FormItem`
      Returns:
        Current canFocus value. Default value is true
      See Also:
        `Focus overview and related methods`

    - #### setCanTabToIcons

          public void setCanTabToIcons(java.lang.Boolean canTabToIcons)

      MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element. `canTabToIcons` is overridden to achieve this even if the property has been set to `false` at the `form level`.

      Note : This is an advanced setting

      Overrides:
        `setCanTabToIcons` in class `FormItem`
      Parameters:
        `canTabToIcons` - New canTabToIcons value. Default value is true

    - #### getCanTabToIcons

          public java.lang.Boolean getCanTabToIcons()

      MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element. `canTabToIcons` is overridden to achieve this even if the property has been set to `false` at the `form level`.
      Overrides:
        `getCanTabToIcons` in class `FormItem`
      Returns:
        Current canTabToIcons value. Default value is true

    - #### setDateDisplayFormat

          public void setDateDisplayFormat(DateDisplayFormat dateDisplayFormat)

      Format for displaying dates to the user.

      If this attribute is unset, the display value is formatted intelligently according to the dates involved. For example, if both dates appear in the same month, the value will be formatted as

      `Month date1 - date2, Year`

      and, if in different months of the same year,

      `Month1 date1 - Month2 date2, Year`.

      If either date-value is unset, the display-value is formatted according to `fromDateOnlyPrefix` and `toDateOnlyPrefix`.

      Parameters:
        `dateDisplayFormat` - New dateDisplayFormat value. Default value is null

    - #### getDateDisplayFormat

          public DateDisplayFormat getDateDisplayFormat()

      Format for displaying dates to the user.

      If this attribute is unset, the display value is formatted intelligently according to the dates involved. For example, if both dates appear in the same month, the value will be formatted as

      `Month date1 - date2, Year`

      and, if in different months of the same year,

      `Month1 date1 - Month2 date2, Year`.

      If either date-value is unset, the display-value is formatted according to `fromDateOnlyPrefix` and `toDateOnlyPrefix`.

      Returns:
        Current dateDisplayFormat value. Default value is null

    - #### setFromDateOnlyPrefix

          public void setFromDateOnlyPrefix(java.lang.String fromDateOnlyPrefix)

      The text to prepend to the formatted date when only a `fromDate` is supplied.
      Parameters:
        `fromDateOnlyPrefix` - New fromDateOnlyPrefix value. Default value is "Since"

    - #### getFromDateOnlyPrefix

          public java.lang.String getFromDateOnlyPrefix()

      The text to prepend to the formatted date when only a `fromDate` is supplied.
      Returns:
        Current fromDateOnlyPrefix value. Default value is "Since"

    - #### setPickerIcon

          public void setPickerIcon(FormItemIcon pickerIcon)

      Icon that launches a `DateChooser` for choosing an absolute date.
      Parameters:
        `pickerIcon` - New pickerIcon value. Default value is null

    - #### getPickerIcon

          public FormItemIcon getPickerIcon()

      Icon that launches a `DateChooser` for choosing an absolute date.
      Returns:
        Current pickerIcon value. Default value is null

    - #### setPickerIconPrompt

          public void setPickerIconPrompt(java.lang.String pickerIconPrompt)

      The prompt to show when the mouse is hovered over the `pickerIcon`.
      Overrides:
        `setPickerIconPrompt` in class `FormItem`
      Parameters:
        `pickerIconPrompt` - New pickerIconPrompt value. Default value is "Show Date Chooser"
      See Also:
        `HTMLString`

    - #### getPickerIconPrompt

          public java.lang.String getPickerIconPrompt()

      The prompt to show when the mouse is hovered over the `pickerIcon`.
      Overrides:
        `getPickerIconPrompt` in class `FormItem`
      Returns:
        Current pickerIconPrompt value. Default value is "Show Date Chooser"
      See Also:
        `HTMLString`

    - #### getRangeDialog

          public DateRangeDialog getRangeDialog()

      Pop-up `DateRangeDialog` for entering a date range.

      This component is an AutoChild named "rangeDialog". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current rangeDialog value. Default value is null

    - #### setShouldSaveValue

          public void setShouldSaveValue(java.lang.Boolean shouldSaveValue)

      Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `setShouldSaveValue` in class `FormItem`
      Parameters:
        `shouldSaveValue` - New shouldSaveValue value. Default value is true

    - #### getShouldSaveValue

          public java.lang.Boolean getShouldSaveValue()

      Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `getShouldSaveValue` in class `FormItem`
      Returns:
        Current shouldSaveValue value. Default value is true

    - #### setTextBoxStyle

          public void setTextBoxStyle(java.lang.String textBoxStyle)

      Base CSS class name for a form item's text box element.

      See `FormItemStyling` for an overview of formItem styling, and the `CompoundFormItem_skinning` discussion for special skinning considerations.

      If the `textBoxStyle` is changed at runtime, `updateState()` must be called to update the visual state of this item.

      Overrides:
        `setTextBoxStyle` in class `StaticTextItem`
      Parameters:
        `textBoxStyle` - New textBoxStyle value. Default value is "textItem"
      See Also:
        `FormItem.setCellStyle(java.lang.String)`, `FormItemBaseStyle`, `FormItemStyling overview and related methods`

    - #### getTextBoxStyle

          public java.lang.String getTextBoxStyle()

      Base CSS class name for a form item's text box element.

      See `FormItemStyling` for an overview of formItem styling, and the `CompoundFormItem_skinning` discussion for special skinning considerations.

      If the `textBoxStyle` is changed at runtime, `updateState()` must be called to update the visual state of this item.

      Overrides:
        `getTextBoxStyle` in class `StaticTextItem`
      Returns:
        Current textBoxStyle value. Default value is "textItem"
      See Also:
        `FormItem.getCellStyle()`, `FormItemBaseStyle`, `FormItemStyling overview and related methods`

    - #### setToDateOnlyPrefix

          public void setToDateOnlyPrefix(java.lang.String toDateOnlyPrefix)

      The text to prepend to the formatted date when only a `toDate` is supplied.
      Parameters:
        `toDateOnlyPrefix` - New toDateOnlyPrefix value. Default value is "Before"

    - #### getToDateOnlyPrefix

          public java.lang.String getToDateOnlyPrefix()

      The text to prepend to the formatted date when only a `toDate` is supplied.
      Returns:
        Current toDateOnlyPrefix value. Default value is "Before"

    - #### hasAdvancedCriteria

          public java.lang.Boolean hasAdvancedCriteria()

      Overridden to return true: dateRangeItems always generate AdvancedCriteria.
      Overrides:
        `hasAdvancedCriteria` in class `FormItem`
      Returns:
        true
      See Also:
        `CriteriaEditing overview and related methods`

    - #### setDefaultProperties

          public static void setDefaultProperties(MiniDateRangeItem miniDateRangeItemProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `miniDateRangeItemProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setFromDate

          public void setFromDate(java.util.Date fromDate)

      Initial value for the "from" date. Sets the `fromDate` for this DateRangeItem.
      Parameters:
        `fromDate` - the date from which this item should start it's range. Default value is today

    - #### getFromDate

          public java.util.Date getFromDate()

      Initial value for the "from" date.
      Returns:
        java.util.Date

    - #### setToDate

          public void setToDate(java.util.Date toDate)

      Initial value for the "to" date. Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. Default value is today

    - #### getToDate

          public java.util.Date getToDate()

      Initial value for the "to" date.
      Returns:
        java.util.Date

    - #### getValue

          public DateRange getValue()

      Retrieves the current value of this dateRangeItem. The return value is a `DateRange` object that excludes start and end values if they aren't set.
      Overrides:
        `getValue` in class `FormItem`
      Returns:
        the current value of this item

    - #### setValue

          public void setValue(DateRange value)

      Sets the value for this dateRangeItem. The value parameter is a `DateRange` object that optionally includes both start and end values.
      Parameters:
        `value` - the new value for this item

    - #### setCriterionGetter

          public void setCriterionGetter(FormItemCriterionGetter getter)

      The default `getCriterion()` implementation returns the Criterion entered in the fields shown in the `rangeDialog`.

      If both dates are entered, a Criterion with an "and" `operator` and both "greaterOrEqual" and "lessOrEqual" sub-criteria will be returned. If either date is omitted, only the "greaterOrEqual" (from date) or "lessOrEqual" (to date) Criterion is returned.

      Overrides:
        `setCriterionGetter` in class `FormItem`
      Parameters:
        `getter` - provides a method to get a criterion object based on this field's current edited value(s).
      See Also:
        `FormItem.setCriterionGetter(com.smartgwt.client.widgets.form.FormItemCriterionGetter)`, `CriteriaEditing overview and related methods`